diff --git a/src/test/regress/sql/timestamptz.sql b/src/test/regress/sql/timestamptz.sql
index f4b455e..1571f45 100644
--- a/src/test/regress/sql/timestamptz.sql
+++ b/src/test/regress/sql/timestamptz.sql
@@ -432,3 +432,207 @@ SELECT '2007-12-09 07:00:00 UTC'::timestamptz AT TIME ZONE 'VET';
 SELECT '2007-12-09 07:00:01 UTC'::timestamptz AT TIME ZONE 'VET';
 SELECT '2007-12-09 07:29:59 UTC'::timestamptz AT TIME ZONE 'VET';
 SELECT '2007-12-09 07:30:00 UTC'::timestamptz AT TIME ZONE 'VET';
+
+-- corner cases
+-- (to prevent raising errors in *_out functions insert values to a table and then select from it)
+SET TIME ZONE 'UTC';
+
+CREATE TABLE test_timestamptzs(txt TEXT, val timestamptz);
+
+-- previously it resulted OK, +inf, -inf, ERROR (in timestamp_out!)
+INSERT INTO test_timestamptzs SELECT v::text, v::timestamptz FROM(VALUES('294277-01-09 03:00:54.775806-01'))t(v);  -- should fail
+INSERT INTO test_timestamptzs SELECT v::text, v::timestamptz FROM(VALUES('294277-01-09 03:00:54.775807-01'))t(v);  -- should fail
+INSERT INTO test_timestamptzs SELECT v::text, v::timestamptz FROM(VALUES('294277-01-09 03:00:54.775808-01'))t(v);  -- should fail
+INSERT INTO test_timestamptzs SELECT v::text, v::timestamptz FROM(VALUES('294277-01-09 03:00:54.775809-01'))t(v);  -- should fail
+
+-- current corner cases
+INSERT INTO test_timestamptzs SELECT v::text, v::timestamptz FROM(VALUES('4714-11-23 23:59:59.999999 BC'))t(v);  -- should fail
+INSERT INTO test_timestamptzs SELECT v::text, v::timestamptz FROM(VALUES('4714-11-24 00:00:00.000000 BC'))t(v);  -- OK
+INSERT INTO test_timestamptzs SELECT v::text, v::timestamptz FROM(VALUES('4713-01-01 00:00:00.000000 BC'))t(v);  -- OK
+INSERT INTO test_timestamptzs SELECT v::text, v::timestamptz FROM(VALUES('294276-12-31 23:59:59.999999'))t(v);  -- OK
+INSERT INTO test_timestamptzs SELECT v::text, v::timestamptz FROM(VALUES('294276-12-31 24:00:00.000000'))t(v);  -- should fail
+INSERT INTO test_timestamptzs SELECT v::text, v::timestamptz FROM(VALUES('294277-01-01 00:00:00.000000'))t(v);  -- should fail
+
+-- current corner cases with non-UTC time zones
+INSERT INTO test_timestamptzs SELECT v::text, v::timestamptz FROM(VALUES('4714-11-24 00:59:59.999999+01 BC'))t(v);  -- should fail
+INSERT INTO test_timestamptzs SELECT v::text, v::timestamptz FROM(VALUES('4714-11-24 01:00:00.000000+01 BC'))t(v);  -- OK
+INSERT INTO test_timestamptzs SELECT v::text, v::timestamptz FROM(VALUES('4713-01-01 01:00:00.000000+01 BC'))t(v);  -- OK
+INSERT INTO test_timestamptzs SELECT v::text, v::timestamptz FROM(VALUES('294276-12-31 22:59:59.999999-01'))t(v);  -- OK
+INSERT INTO test_timestamptzs SELECT v::text, v::timestamptz FROM(VALUES('294276-12-31 23:00:00.000000-01'))t(v);  -- should fail
+
+-- current corner cases with make_timestamptz(current tz=UTC) (note: negative years are not allowed)
+INSERT INTO test_timestamptzs SELECT format('%s-%s-%s %s:%s:%s', y,m,d,h,mm,s), make_timestamptz(y,m,d,h,mm,s) FROM(VALUES(294276,12,31, 23,59,59.999999))t(y,m,d,h,mm,s);  -- OK
+INSERT INTO test_timestamptzs SELECT format('%s-%s-%s %s:%s:%s', y,m,d,h,mm,s), make_timestamptz(y,m,d,h,mm,s) FROM(VALUES(294276,12,31, 24,00,00.000000))t(y,m,d,h,mm,s);  -- should fail
+INSERT INTO test_timestamptzs SELECT format('%s-%s-%s %s:%s:%s', y,m,d,h,mm,s), make_timestamptz(y,m,d,h,mm,s) FROM(VALUES(294277,01,01, 00,00,00.000000))t(y,m,d,h,mm,s);  -- should fail
+
+-- current corner cases with make_timestamptz(in non-UTC TZ) (note: negative years are not allowed)
+INSERT INTO test_timestamptzs SELECT format('%s-%s-%s %s:%s:%s %s', y,m,d,h,mm,s,tz), make_timestamptz(y,m,d,h,mm,s,tz) FROM(VALUES(294276,12,31, 23,59,59.999999, 'GMT+0'))t(y,m,d,h,mm,s,tz);  -- OK
+INSERT INTO test_timestamptzs SELECT format('%s-%s-%s %s:%s:%s %s', y,m,d,h,mm,s,tz), make_timestamptz(y,m,d,h,mm,s,tz) FROM(VALUES(294276,12,31, 22,59,59.999999, 'GMT+1'))t(y,m,d,h,mm,s,tz);  -- OK
+INSERT INTO test_timestamptzs SELECT format('%s-%s-%s %s:%s:%s %s', y,m,d,h,mm,s,tz), make_timestamptz(y,m,d,h,mm,s,tz) FROM(VALUES(294276,12,31, 23,00,00.000000, 'GMT+1'))t(y,m,d,h,mm,s,tz);  -- should fail
+
+-- conversion from date (has bigger allowed interval)
+INSERT INTO test_timestamptzs SELECT v::text, v::date::timestamptz FROM(VALUES('4714-11-23 BC'))t(v);  -- should fail
+INSERT INTO test_timestamptzs SELECT v::text, v::date::timestamptz FROM(VALUES('4714-11-24 BC'))t(v);  -- OK
+INSERT INTO test_timestamptzs SELECT v::text, v::date::timestamptz FROM(VALUES('294276-12-31'))t(v);  -- OK
+INSERT INTO test_timestamptzs SELECT v::text, v::date::timestamptz FROM(VALUES('294277-01-01'))t(v);  -- should fail
+
+-- check for overflow because of time zones
+SET TIME ZONE 'GMT-1';
+INSERT INTO test_timestamptzs SELECT v::text, v::date::timestamptz FROM(VALUES('4714-11-22 BC'))t(v);  -- should fail
+INSERT INTO test_timestamptzs SELECT v::text, v::date::timestamptz FROM(VALUES('4714-11-23 BC'))t(v);  -- should fail
+INSERT INTO test_timestamptzs SELECT v::text, v::date::timestamptz FROM(VALUES('4714-11-24 BC'))t(v);  -- should fail (-4714-11-23 23:00:00)
+INSERT INTO test_timestamptzs SELECT v::text, v::date::timestamptz FROM(VALUES('4714-11-25 BC'))t(v);  -- OK
+INSERT INTO test_timestamptzs SELECT v::text, v::date::timestamptz FROM(VALUES('294276-12-30'))t(v);  -- OK
+INSERT INTO test_timestamptzs SELECT v::text, v::date::timestamptz FROM(VALUES('294276-12-31'))t(v);  -- OK
+INSERT INTO test_timestamptzs SELECT v::text, v::date::timestamptz FROM(VALUES('294277-01-01'))t(v);  -- should fail
+INSERT INTO test_timestamptzs SELECT v::text, v::date::timestamptz FROM(VALUES('294277-01-02'))t(v);  -- should fail
+
+SET TIME ZONE 'GMT+1';
+INSERT INTO test_timestamptzs SELECT v::text, v::date::timestamptz FROM(VALUES('4714-11-22 BC'))t(v);  -- should fail
+INSERT INTO test_timestamptzs SELECT v::text, v::date::timestamptz FROM(VALUES('4714-11-23 BC'))t(v);  -- should fail
+INSERT INTO test_timestamptzs SELECT v::text, v::date::timestamptz FROM(VALUES('4714-11-24 BC'))t(v);  -- OK
+INSERT INTO test_timestamptzs SELECT v::text, v::date::timestamptz FROM(VALUES('4714-11-25 BC'))t(v);  -- OK
+INSERT INTO test_timestamptzs SELECT v::text, v::date::timestamptz FROM(VALUES('294276-12-30'))t(v);  -- OK
+INSERT INTO test_timestamptzs SELECT v::text, v::date::timestamptz FROM(VALUES('294276-12-31'))t(v);  -- OK
+INSERT INTO test_timestamptzs SELECT v::text, v::date::timestamptz FROM(VALUES('294277-01-01'))t(v);  -- should fail
+INSERT INTO test_timestamptzs SELECT v::text, v::date::timestamptz FROM(VALUES('294277-01-02'))t(v);  -- should fail
+
+-- restore UTC by default
+SET TIME ZONE 'UTC';
+
+-- conversion from date+time (has bigger allowed interval)
+INSERT INTO test_timestamptzs SELECT format('%s %s', d::text, t::text), "timestamptz"(d::date, t::timetz) FROM(VALUES('4714-11-23 BC', '23:59:59.999999'))t(d,t);  -- should fail
+INSERT INTO test_timestamptzs SELECT format('%s %s', d::text, t::text), "timestamptz"(d::date, t::timetz) FROM(VALUES('4714-11-23 BC', '24:00:00.000000'))t(d,t);  -- should fail
+INSERT INTO test_timestamptzs SELECT format('%s %s', d::text, t::text), "timestamptz"(d::date, t::timetz) FROM(VALUES('4714-11-24 BC', '00:00:00.000000'))t(d,t);  -- OK
+INSERT INTO test_timestamptzs SELECT format('%s %s', d::text, t::text), "timestamptz"(d::date, t::timetz) FROM(VALUES('294276-12-31',  '23:59:59.999999'))t(d,t);  -- OK
+INSERT INTO test_timestamptzs SELECT format('%s %s', d::text, t::text), "timestamptz"(d::date, t::timetz) FROM(VALUES('294276-12-31',  '24:00:00.000000'))t(d,t);  -- should fail
+INSERT INTO test_timestamptzs SELECT format('%s %s', d::text, t::text), "timestamptz"(d::date, t::timetz) FROM(VALUES('294277-01-01',  '00:00:00.000000'))t(d,t);  -- should fail
+
+-- conversion from date+timeTZ (has bigger allowed interval)
+INSERT INTO test_timestamptzs SELECT format('%s %s', d::text, t::text), "timestamptz"(d::date, t::timetz) FROM(VALUES('4714-11-23 BC', '23:59:59.999999-01'))t(d,t);  -- should fail
+INSERT INTO test_timestamptzs SELECT format('%s %s', d::text, t::text), "timestamptz"(d::date, t::timetz) FROM(VALUES('4714-11-23 BC', '24:00:00.000000-01'))t(d,t);  -- should fail
+INSERT INTO test_timestamptzs SELECT format('%s %s', d::text, t::text), "timestamptz"(d::date, t::timetz) FROM(VALUES('4714-11-24 BC', '00:00:00.000000-01'))t(d,t);  -- OK
+INSERT INTO test_timestamptzs SELECT format('%s %s', d::text, t::text), "timestamptz"(d::date, t::timetz) FROM(VALUES('4714-11-24 BC', '00:59:59.999999-01'))t(d,t);  -- OK
+INSERT INTO test_timestamptzs SELECT format('%s %s', d::text, t::text), "timestamptz"(d::date, t::timetz) FROM(VALUES('4714-11-24 BC', '01:00:00.000000-01'))t(d,t);  -- OK
+INSERT INTO test_timestamptzs SELECT format('%s %s', d::text, t::text), "timestamptz"(d::date, t::timetz) FROM(VALUES('294276-12-31',  '22:59:59.999999-01'))t(d,t);  -- OK
+INSERT INTO test_timestamptzs SELECT format('%s %s', d::text, t::text), "timestamptz"(d::date, t::timetz) FROM(VALUES('294276-12-31',  '23:00:00.000000-01'))t(d,t);  -- should fail
+INSERT INTO test_timestamptzs SELECT format('%s %s', d::text, t::text), "timestamptz"(d::date, t::timetz) FROM(VALUES('294276-12-31',  '23:59:59.999999-01'))t(d,t);  -- should fail
+INSERT INTO test_timestamptzs SELECT format('%s %s', d::text, t::text), "timestamptz"(d::date, t::timetz) FROM(VALUES('294276-12-31',  '24:00:00.000000-01'))t(d,t);  -- should fail
+
+INSERT INTO test_timestamptzs SELECT format('%s %s', d::text, t::text), "timestamptz"(d::date, t::timetz) FROM(VALUES('4714-11-23 BC', '23:59:59.999999+01'))t(d,t);  -- should fail
+INSERT INTO test_timestamptzs SELECT format('%s %s', d::text, t::text), "timestamptz"(d::date, t::timetz) FROM(VALUES('4714-11-23 BC', '24:00:00.000000+01'))t(d,t);  -- should fail
+INSERT INTO test_timestamptzs SELECT format('%s %s', d::text, t::text), "timestamptz"(d::date, t::timetz) FROM(VALUES('4714-11-24 BC', '00:00:00.000000+01'))t(d,t);  -- should fail
+INSERT INTO test_timestamptzs SELECT format('%s %s', d::text, t::text), "timestamptz"(d::date, t::timetz) FROM(VALUES('4714-11-24 BC', '00:59:59.999999+01'))t(d,t);  -- should fail
+INSERT INTO test_timestamptzs SELECT format('%s %s', d::text, t::text), "timestamptz"(d::date, t::timetz) FROM(VALUES('4714-11-24 BC', '01:00:00.000000+01'))t(d,t);  -- OK
+INSERT INTO test_timestamptzs SELECT format('%s %s', d::text, t::text), "timestamptz"(d::date, t::timetz) FROM(VALUES('294276-12-31',  '22:59:59.999999+01'))t(d,t);  -- OK
+INSERT INTO test_timestamptzs SELECT format('%s %s', d::text, t::text), "timestamptz"(d::date, t::timetz) FROM(VALUES('294276-12-31',  '23:00:00.000000+01'))t(d,t);  -- OK
+INSERT INTO test_timestamptzs SELECT format('%s %s', d::text, t::text), "timestamptz"(d::date, t::timetz) FROM(VALUES('294276-12-31',  '23:59:59.999999+01'))t(d,t);  -- OK
+INSERT INTO test_timestamptzs SELECT format('%s %s', d::text, t::text), "timestamptz"(d::date, t::timetz) FROM(VALUES('294276-12-31',  '24:00:00.000000+01'))t(d,t);  -- OK
+
+
+SELECT txt, val FROM test_timestamptzs;
+DROP TABLE test_timestamptzs;
+
+
+-- truncating tests
+CREATE TABLE test_timestamptzs(txt TEXT, unit text, val timestamptz);
+-- truncating minimum allowed value results to even less value (not allowed)
+INSERT INTO test_timestamptzs SELECT v::text, u, date_trunc(u, v::timestamptz) FROM(VALUES('day',   '4714-11-24 00:00:00.000000 BC'))t(u,v);  -- OK
+INSERT INTO test_timestamptzs SELECT v::text, u, date_trunc(u, v::timestamptz) FROM(VALUES('week',  '4714-11-24 00:00:00.000000 BC'))t(u,v);  -- should fail
+INSERT INTO test_timestamptzs SELECT v::text, u, date_trunc(u, v::timestamptz) FROM(VALUES('month', '4714-11-30 23:59:59.999999 BC'))t(u,v);  -- should fail
+INSERT INTO test_timestamptzs SELECT v::text, u, date_trunc(u, v::timestamptz) FROM(VALUES('year',  '4714-12-31 23:59:59.999999 BC'))t(u,v);  -- should fail
+
+SELECT txt, unit, val FROM test_timestamptzs;
+DROP TABLE test_timestamptzs;
+
+
+-- time zone conversions tests
+CREATE TABLE test_timestamptzs(txt TEXT, tz text, val timestamp);
+INSERT INTO test_timestamptzs SELECT v::text, tz, v::timestamptz AT TIME ZONE tz FROM(VALUES('GMT-1',  '4714-11-24 00:59:59.999999 BC'))t(tz,v);  -- should fail
+INSERT INTO test_timestamptzs SELECT v::text, tz, v::timestamptz AT TIME ZONE tz FROM(VALUES('GMT-1',  '4714-11-24 01:00:00.000000 BC'))t(tz,v);  -- OK
+INSERT INTO test_timestamptzs SELECT v::text, tz, v::timestamptz AT TIME ZONE tz FROM(VALUES('GMT+0',  '4714-11-24 00:59:59.999999 BC'))t(tz,v);  -- OK
+
+INSERT INTO test_timestamptzs SELECT v::text, tz, v::timestamptz AT TIME ZONE tz FROM(VALUES('GMT+0',  '294276-12-31 23:59:59.999999'))t(tz,v);  -- OK
+INSERT INTO test_timestamptzs SELECT v::text, tz, v::timestamptz AT TIME ZONE tz FROM(VALUES('GMT+1',  '294276-12-31 22:59:59.999999'))t(tz,v);  -- OK
+INSERT INTO test_timestamptzs SELECT v::text, tz, v::timestamptz AT TIME ZONE tz FROM(VALUES('GMT+1',  '294276-12-31 23:00:00.000000'))t(tz,v);  -- should fail
+
+SELECT txt, tz, val FROM test_timestamptzs;
+DROP TABLE test_timestamptzs;
+
+
+-- arithmetic operations
+CREATE TABLE test_timestamptzs(txt TEXT, delta INTERVAL, val timestamptz);
+
+-- the same as '294277-01-09 04:00:54.77580*'::timestamptz (with months)  [should fail]
+INSERT INTO test_timestamptzs SELECT v::text, d::interval, v::timestamptz + d::interval FROM(VALUES('294247-01-09', '360 months 04:00:54.775806'))t(v, d);
+INSERT INTO test_timestamptzs SELECT v::text, d::interval, v::timestamptz + d::interval FROM(VALUES('294247-01-09', '360 months 04:00:54.775807'))t(v, d);
+INSERT INTO test_timestamptzs SELECT v::text, d::interval, v::timestamptz + d::interval FROM(VALUES('294247-01-09', '360 months 04:00:54.775808'))t(v, d);
+INSERT INTO test_timestamptzs SELECT v::text, d::interval, v::timestamptz + d::interval FROM(VALUES('294247-01-09', '360 months 04:00:54.775809'))t(v, d);
+
+-- the same as '294277-01-09 04:00:54.77580*'::timestamptz (with days)  [should fail]
+INSERT INTO test_timestamptzs SELECT v::text, d::interval, v::timestamptz + d::interval FROM(VALUES('294247-01-10', '10957 days 04:00:54.775806'))t(v, d);
+INSERT INTO test_timestamptzs SELECT v::text, d::interval, v::timestamptz + d::interval FROM(VALUES('294247-01-10', '10957 days 04:00:54.775807'))t(v, d);
+INSERT INTO test_timestamptzs SELECT v::text, d::interval, v::timestamptz + d::interval FROM(VALUES('294247-01-10', '10957 days 04:00:54.775808'))t(v, d);
+INSERT INTO test_timestamptzs SELECT v::text, d::interval, v::timestamptz + d::interval FROM(VALUES('294247-01-10', '10957 days 04:00:54.775809'))t(v, d);
+
+-- the same as '294277-01-09 04:00:54.77580*'::timestamptz (with hours)  [should fail]
+INSERT INTO test_timestamptzs SELECT v::text, d::interval, v::timestamptz + d::interval FROM(VALUES('294247-01-10',        '262972:00:54.775806'))t(v, d);
+INSERT INTO test_timestamptzs SELECT v::text, d::interval, v::timestamptz + d::interval FROM(VALUES('294247-01-10',        '262972:00:54.775807'))t(v, d);
+INSERT INTO test_timestamptzs SELECT v::text, d::interval, v::timestamptz + d::interval FROM(VALUES('294247-01-10',        '262972:00:54.775808'))t(v, d);
+INSERT INTO test_timestamptzs SELECT v::text, d::interval, v::timestamptz + d::interval FROM(VALUES('294247-01-10',        '262972:00:54.775809'))t(v, d);
+
+-- the same as '294277-01-09 04:00:54.77580*'::timestamptz (with seconds)  [should fail]
+INSERT INTO test_timestamptzs SELECT v::text, d::interval, v::timestamptz + d::interval FROM(VALUES('294247-01-10',           '946699254.775806'))t(v, d);
+INSERT INTO test_timestamptzs SELECT v::text, d::interval, v::timestamptz + d::interval FROM(VALUES('294247-01-10',           '946699254.775807'))t(v, d);
+INSERT INTO test_timestamptzs SELECT v::text, d::interval, v::timestamptz + d::interval FROM(VALUES('294247-01-10',           '946699254.775808'))t(v, d);
+INSERT INTO test_timestamptzs SELECT v::text, d::interval, v::timestamptz + d::interval FROM(VALUES('294247-01-10',           '946699254.775809'))t(v, d);
+
+-- current corner cases
+INSERT INTO test_timestamptzs SELECT v::text, d::interval, v::timestamptz + d::interval FROM(VALUES('4714-11-24 BC', '-1mon'))t(v, d);  -- should fail
+INSERT INTO test_timestamptzs SELECT v::text, d::interval, v::timestamptz + d::interval FROM(VALUES('4714-11-24 BC', '-1day'))t(v, d);  -- should fail
+INSERT INTO test_timestamptzs SELECT v::text, d::interval, v::timestamptz + d::interval FROM(VALUES('4714-11-24 BC', '-1sec'))t(v, d);  -- should fail
+INSERT INTO test_timestamptzs SELECT v::text, d::interval, v::timestamptz + d::interval FROM(VALUES('4714-11-24 BC', '-0.000001sec'))t(v, d);  -- should fail
+INSERT INTO test_timestamptzs SELECT v::text, d::interval, v::timestamptz + d::interval FROM(VALUES('4714-11-24 BC', ' 0sec'))t(v, d);  -- OK
+INSERT INTO test_timestamptzs SELECT v::text, d::interval, v::timestamptz + d::interval FROM(VALUES('4714-11-24 BC', '+0.000001sec'))t(v, d);  -- OK
+INSERT INTO test_timestamptzs SELECT v::text, d::interval, v::timestamptz + d::interval FROM(VALUES('4714-11-24 BC', '+1sec'))t(v, d);  -- OK
+INSERT INTO test_timestamptzs SELECT v::text, d::interval, v::timestamptz + d::interval FROM(VALUES('4714-11-24 BC', '+1sec'))t(v, d);  -- OK
+INSERT INTO test_timestamptzs SELECT v::text, d::interval, v::timestamptz + d::interval FROM(VALUES('4714-11-24 BC', '+1day'))t(v, d);  -- OK
+INSERT INTO test_timestamptzs SELECT v::text, d::interval, v::timestamptz + d::interval FROM(VALUES('4714-11-24 BC', '+1mon'))t(v, d);  -- OK
+
+INSERT INTO test_timestamptzs SELECT v::text, d::interval, v::timestamptz + d::interval FROM(VALUES('294276-12-31 23:59:59.999999', '-1mon'))t(v, d);  -- OK
+INSERT INTO test_timestamptzs SELECT v::text, d::interval, v::timestamptz + d::interval FROM(VALUES('294276-12-31 23:59:59.999999', '-1day'))t(v, d);  -- OK
+INSERT INTO test_timestamptzs SELECT v::text, d::interval, v::timestamptz + d::interval FROM(VALUES('294276-12-31 23:59:59.999999', '-1sec'))t(v, d);  -- OK
+INSERT INTO test_timestamptzs SELECT v::text, d::interval, v::timestamptz + d::interval FROM(VALUES('294276-12-31 23:59:59.999999', '-0.000001sec'))t(v, d);  -- OK
+INSERT INTO test_timestamptzs SELECT v::text, d::interval, v::timestamptz + d::interval FROM(VALUES('294276-12-31 23:59:59.999999', ' 0sec'))t(v, d);  -- OK
+INSERT INTO test_timestamptzs SELECT v::text, d::interval, v::timestamptz + d::interval FROM(VALUES('294276-12-31 23:59:59.999999', '+0.000001sec'))t(v, d);  -- should fail
+INSERT INTO test_timestamptzs SELECT v::text, d::interval, v::timestamptz + d::interval FROM(VALUES('294276-12-31 23:59:59.999999', '+1sec'))t(v, d);  -- should fail
+INSERT INTO test_timestamptzs SELECT v::text, d::interval, v::timestamptz + d::interval FROM(VALUES('294276-12-31 23:59:59.999999', '+1sec'))t(v, d);  -- should fail
+INSERT INTO test_timestamptzs SELECT v::text, d::interval, v::timestamptz + d::interval FROM(VALUES('294276-12-31 23:59:59.999999', '+1day'))t(v, d);  -- should fail
+INSERT INTO test_timestamptzs SELECT v::text, d::interval, v::timestamptz + d::interval FROM(VALUES('294276-12-31 23:59:59.999999', '+1mon'))t(v, d);  -- should fail
+
+-- try to add/substract maximal/minimal intervals (check for unexpected overflow)
+-- years, months
+INSERT INTO test_timestamptzs SELECT v::text, d::interval, v::timestamptz + d::interval FROM(VALUES('294276-12-31 23:59:59.999999',  '+2147483647mon'))t(v, d);  -- should fail
+INSERT INTO test_timestamptzs SELECT v::text, d::interval, v::timestamptz + d::interval FROM(VALUES('294276-12-31 23:59:59.999999',  '-2147483648mon'))t(v, d);  -- should fail
+INSERT INTO test_timestamptzs SELECT v::text, d::interval, v::timestamptz + d::interval FROM(VALUES('4714-11-24 01:00:00.000000 BC', '+2147483647mon'))t(v, d);  -- should fail
+INSERT INTO test_timestamptzs SELECT v::text, d::interval, v::timestamptz + d::interval FROM(VALUES('4714-11-24 01:00:00.000000 BC', '-2147483648mon'))t(v, d);  -- should fail
+-- days
+INSERT INTO test_timestamptzs SELECT v::text, d::interval, v::timestamptz + d::interval FROM(VALUES('294276-12-31 23:59:59.999999',  '+2147483647day'))t(v, d);  -- should fail
+INSERT INTO test_timestamptzs SELECT v::text, d::interval, v::timestamptz + d::interval FROM(VALUES('294276-12-31 23:59:59.999999',  '-2147483648day'))t(v, d);  -- should fail
+INSERT INTO test_timestamptzs SELECT v::text, d::interval, v::timestamptz + d::interval FROM(VALUES('4714-11-24 01:00:00.000000 BC', '+2147483647day'))t(v, d);  -- should fail
+INSERT INTO test_timestamptzs SELECT v::text, d::interval, v::timestamptz + d::interval FROM(VALUES('4714-11-24 01:00:00.000000 BC', '-2147483648day'))t(v, d);  -- should fail
+
+SELECT txt, delta, val FROM test_timestamptzs;
+DROP TABLE test_timestamptzs;
+
+-- IN/OUT in different time zones
+SET TIME ZONE 'GMT-1';
+SELECT '4714-11-24 00:00:00.000000+00 BC'::timestamptz;  --min allowed timestamptz
+SELECT '294276-12-31 23:59:59.999999+00'::timestamptz;   --max allowed timestamptz
+
+SET TIME ZONE 'GMT+1';
+SELECT '4714-11-24 00:00:00.000000+00 BC'::timestamptz;  --min allowed timestamptz
+SELECT '294276-12-31 23:59:59.999999+00'::timestamptz;   --max allowed timestamptz
+
+
+RESET TIME ZONE;
